<template src="./template.html"></template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import { api, regexEmail } from "~/common/constaint";
import { apiErrorHandler, redirectPage } from "~/utils/apiHanlers";
import Swal from "sweetalert2";
import CartModule from "~/store/cart";
import ProductModule from "~/store/product";
// @ts-ignore
import countryCode from "~/countries/CountryCodes.json";
// @ts-ignore
import usStates from "~/countries/us-states";
// @ts-ignore
import canadaState from "~/countries/canada-states";
// @ts-ignore
import australiaState from "~/countries/au-states";
var momentz = require("moment-timezone");
var moment = require("moment");
//@ts-ignore
import listCountry from "~/locales/listCountry.json";
//@ts-ignore
import listAllCountry from "~/locales/listAllCountry.json";
import CountryFlag from "vue-country-flag";
import { objectToParam } from "~/common/utils";
import utmQuery from "~/utils/utmQuery";
import checkCart from "~/utils/checkCart";
import getIp from "~/utils/getIp";
import {
  trackEventAddPaymentInfo,
  trackEventCheckoutInitiated,
} from "~/utils/trackEvent";
import { watch } from "vue/types";
import { IItemListShipping } from "~/interfaces/shipping";
import sitePage from "~/store/sitePage";
import {
  onClearSession,
  onGetCheckoutInfo,
  onGetListCart,
  onSetCheckoutInfo,
  onSetItemLocalStorage,
} from "~/utils/localStorage";
import { getSessionId, randomCharacter, setSessionId } from "~/utils/sessionId";
interface IItemCountry {
  name: string;
  code: string;
}

@Component({
  components: {
    CountryFlag,
    PaypalCheckout: () => import("./Paypal/index.vue"),
    StripeCheckout: () => import("./Stripe/index.vue"),
  },
})
export default class CheckoutComponent extends Vue {
  countryCode = countryCode;
  usStates = usStates;
  canadaState = canadaState;
  australiaState = australiaState;
  listStateCountry: any = [];
  listStateBillingCountry: any = [];
  cartModule = getModule(CartModule, this.$store);
  productModule = getModule(ProductModule, this.$store);
  siteInfoModule = getModule(sitePage, this.$store);

  config: any = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;

  listShipping = [];
  listCountrySort = listCountry;
  listAllCountry = listAllCountry;

  loadingTable = false;
  loadingStripe = false;

  checkout = {
    shippingAddress: {
      email: "",
      firstName: "",
      lastName: "",
      address: "",
      apartment: "",
      // companyName: "",
      zipCode: "",
      city: "",
      state: "",
      country: "United States",
      phoneNumber: "",
    },
    billingAddress: {
      email: "",
      firstName: "",
      lastName: "",
      address: "",
      apartment: "",
      // companyName: "",
      zipCode: "",
      city: "",
      state: "",
      country: "United States",
      phoneNumber: "",
    },
    shippingId: "",
    couponCode: "",
    orderCode: "",
    payment: "",
    tip: 0,
    card: {
      cardNumber: "4000000000003220",
      exp_year: "25",
      exp_month: "12",
      cvv: "123",
    },
  };

  isSameAddress = "0";

  amount = 0;
  cartId = "";

  cart: any = {};
  listCart: any = [];
  paymentType = "2";
  code: any = "";
  abandonedId: any = "";
  isAbandon = false;
  coupon: any = {};
  loading = false;
  loadingDiscount = false;
  billingAddress = "1";
  addTip = false;
  amountTip: any = null;
  percentTip: any = null;

  listTip = [
    {
      name: "No Tip",
      value: 0,
    },
    {
      name: "$2",
      value: 2,
    },
    {
      name: "$5",
      value: 5,
    },
    {
      name: "$10",
      value: 10,
    },
    {
      name: "$15",
      value: 15,
    },
  ];

  isShowListProduct = true;

  errorField = {
    shippingAddress: {
      isEmail: "",
      isFirstName: "",
      isLastName: "",
      isAddress: "",
      isZipCode: "",
      isCity: "",
      isState: "",
      isPhoneNumber: "",
    },
    billingAddress: {
      isEmail: "",
      isFirstName: "",
      isLastName: "",
      isAddress: "",
      isZipCode: "",
      isCity: "",
      isState: "",
      isPhoneNumber: "",
    },
  };

  head() {
    return {
      title:
        " Checkout - " +
        `${
          this.$store.state?.setting?.settingHomePage?.homepageTitle
            ? `${this.$store.state?.setting?.settingHomePage?.homepageTitle}`
            : (this.$store.state.setting.siteInfo &&
                this.$store.state.setting.siteInfo.storeName +
                  " - " +
                  this.$store.state?.setting?.siteInfo?.productName) ||
              ""
        }`,
      link: [
        {
          rel: "icon",
          type: "image/x-icon",
          href: `${
            this.$store?.state?.setting?.siteInfo?.logo
              ? `${api}/${this.$store?.state?.setting?.siteInfo?.logo}`
              : "/logous.png"
          }`,
        },
      ],
      script: [{ src: "https://js.stripe.com/v3" }],
    };
  }

  timerInterVal: any = null;
  domainWeb = "";
  utmQuery = "";

  isDonePayment = false;

  async mounted() {
    this.$gtag.event("go_checkout_page");
    const { coupon, abandonedId } = this.$route.query;
    if (
      //@ts-ignore
      this.$vuetify.breakpoint.name === "xs" ||
      //@ts-ignore
      this.$vuetify.breakpoint.name === "sm"
    ) {
      this.isShowListProduct = false;
    } else {
      this.isShowListProduct = true;
    }
    //@ts-ignore
    this.checkout.tip = JSON.parse(localStorage.getItem("tip")) || 0;
    trackEventCheckoutInitiated(this);
    utmQuery(this);
    getIp(this.$store, this.$api);
    const query = this.$store.state.sitePage.utm || {};
    this.utmQuery = objectToParam(query);
    this.slug = this.$route.params.slug || "";
    this.domainWeb = window.location.origin || "";
    // handleTwitter(this);
    // this.onGetPromotion()
    const findCountry = countryCode.find(
      (item: IItemCountry) =>
        item.name === this.checkout.shippingAddress.country
    );
    const cart = onGetListCart();
    if (cart && cart.length) {
      this.listCart = cart;
    }
    const proms = [
      this.onGetDetailProduct(),
      this.onGetListShipping(findCountry.code || "US"),
      // this.onGetPixel(),
      this.onGetListPayment(),
      this.onGetListPromotion(),
      this.onGetListSkStripe(),
    ];
    this.siteInfoModule.setLoadingFullPage(true);
    let isCheckCounpon: boolean | undefined = true;
    await Promise.all(proms);
    this.listStateBillingCountry = usStates;
    this.listStateCountry = usStates;
    if (abandonedId) {
      this.abandonedId = abandonedId;
      this.isAbandon = true;
      isCheckCounpon = await this.onGetListCartAbandoned();
    }
    if (coupon && isCheckCounpon) {
      this.code = coupon;
      await this.onCheckCodeCoupon();
    }
    this.setStateCheckout();
    this.onCountCheckout();
    this.siteInfoModule.setLoadingFullPage(false);
    this.$store.commit("product/setDialogAdded", {
      value: false,
      type: "bestSeller",
    });
    this.$store.commit("product/setDialogAdded", {
      value: false,
      type: "recently",
    });
    this.$store.commit("product/setDialogAdded", {
      value: false,
      type: "product",
    });
    // await this.$store.dispatch("promotion/getPromotionDetail", {
    // 	ctx: this,
    // });
    this.timerInterVal = setInterval(() => {
      this.countdownTimer();
    }, 1000);
    this.onCalcTimer();
    this.checkout.payment = "paypal";
    this.onSetCheckoutInfo();
    // this.handleScroll();
  }

  handleScroll() {
    const scrollToContactInformation =
      //@ts-ignore
      this.$refs.contactInformation.getBoundingClientRect().top;
    const isScrollCheckout =
      this.$store.state.product.isScrollCheckout || false;
    if (isScrollCheckout && scrollToContactInformation) {
      window.scrollTo({ top: scrollToContactInformation, behavior: "smooth" });
    }
  }

  async onSetCheckoutInfo() {
    try {
      //@ts-ignore
      const checkout = JSON.parse(onGetCheckoutInfo("checkout"));
      this.isSameAddress =
        //@ts-ignore
        JSON.parse(onGetCheckoutInfo("isSameAddress")) || "0";
      if (checkout) {
        this.checkout = checkout;
        this.checkout.shippingAddress.state = checkout.shippingAddress.state;
      }
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  async onCountCheckout() {
    try {
      let sessionId = getSessionId();
      if (!sessionId) {
        const charRandom = randomCharacter().toLocaleLowerCase();
        const unixTimeStamp = Math.floor(new Date().getTime() / 1000);
        sessionId = `${charRandom}_${unixTimeStamp}`;
        setSessionId(sessionId);
      }
      const query = this.$store.state.sitePage.utm || {};
      const storeId = this.siteInfo?.storeId || "";

      await this.$api.product.countCheckout(
        sessionId,
        storeId,
        this.siteInfo.adminId,
        query
      );
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onCreateAbandoned() {
    try {
      const body = {
        email: this.checkout?.shippingAddress?.email?.toLowerCase(),
        listSelectedProduct: this.listCart.map((variant: any) => ({
          variantSellerId: variant._id,
          quantity: variant.quantity,
        })),
      };
      const domain = this.$store.state?.product?.domain || "";
      await this.$api.cart.createAbandoned(body, domain);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListCartAbandoned() {
    try {
      const response = await this.$api.cart.getCartAbandoned(this.abandonedId);
      if (response.data.length) {
        this.listCart = [];
        for (let item of response.data) {
          item["imageId"] = {
            imageUrl: item.imageUrl || "",
          };

          let listVariant = {};
          for (let i = 0; i < item.listOption.length; i++) {
            let elem: any = {};

            elem[`${item.listOption[i].name}`] = item.listValue[i];
            listVariant = { ...listVariant, ...elem };
          }
          item["listVariant"] = listVariant;
          item["_id"] = item.variantSellerId;
        }
        console.log("response.data :>> ", response.data);
        localStorage.setItem("cart", JSON.stringify(response.data));
        this.$store.commit("cart/setListCart", response.data);
        checkCart(this, this.product);
        this.listCart = this.$store.state.cart?.listCart || [];
        return true;
      } else {
        this.$router.push(`/${this.slug}`);
        return false;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  onSubmitGetListShipping() {
    const findCountry = countryCode.find(
      (item: IItemCountry) =>
        item.name === this.checkout.shippingAddress.country
    );
    this.onGetListShipping(findCountry?.code || "");
  }

  onSelectTip(value: number) {
    this.checkout.tip = value;
  }

  async onGetListPayment() {
    try {
      const domain = this.$store.state.product.domain || "";
      const response = await this.$api.payment.userListPayment(domain);
      if (response?.data) {
        this.$store.commit("cart/setPublicKey", response.data);
        this.$store.commit("cart/setListPayment", response.data);
      }
    } catch (error) {
      console.log("error list payment:>> ", error);
    }
  }

  async onGetListPromotion() {
    try {
      const response = await this.$api.promotion.getPromotion();
      if (response?.data) {
        this.$store.commit("promotion/setPromotion", response.data);
      }
    } catch (error) {}
  }

  async onGetListSkStripe() {
    try {
      const domain = this.$store.state.product.domain || "";
      const response = await this.$api.payment.userSkStripe(domain);
      if (response?.data) {
        this.$store.commit("cart/setPublicKeyStripe", response.data);
      }
    } catch (error) {}
  }

  onTrackingGtag() {
    this.$gtag.event("back_link", {
      event_category: "click back home page",
      event_label: "click back home page",
    });
  }
  async onGetPromotion() {
    try {
      const response = await this.$api.promotion.getPromotion();
      if (response?.data) {
        this.$store.commit("promotion/setPromotion", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  // async onGetPixel() {
  //   try {
  //     const domain = this.slug
  //       ? `${this.slug}.${window.location.host}`
  //       : window.location.host || "";
  //     const response = await this.$api.pixel.getPixel(domain);
  //     if (response?.data) {
  //       const listAdsAnalytic = [
  //         {
  //           name: "google",
  //           platformId: response.data?.googleAds?.googleAnalyticId || "",
  //           googleTagManager: response.data?.googleAds?.googleTagManager || "",
  //         },
  //         {
  //           name: "tiktok",
  //           platformId: response.data?.tiktokPixel?.tikTokPixelId || "",
  //         },
  //         {
  //           name: "facebook",
  //           platformId: response.data?.facebookPixel?.facebookPixelId || "",
  //           contentId: response.data?.facebookPixel?.contentId || "",
  //         },
  //         {
  //           name: "snapchat",
  //           platformId: response.data?.snapPixel?.snapPixelId || "",
  //         },
  //         {
  //           name: "twitter",
  //           platformId: response.data?.twitterPixel || {},
  //         },
  //       ];
  //       this.$store.commit("setting/setAdsAnalytic", listAdsAnalytic);
  //     }
  //   } catch (error) {
  //     apiErrorHandler(error, this);
  //   }
  // }

  async onGetDetailProduct() {
    try {
      await this.productModule.getDetailProduct({ ctx: this });
      // const domain = this.slug
      //   ? `${this.slug}.${window.location.host}`
      //   : window.location.host || "";
      // const response = await this.$api.product.getDetailProductDomain(domain);
      // if (response?.data) {
      //   this.$store.commit("product/setProduct", response.data);
      //   checkCart(this);
      //   //@ts-ignore
      //   this.listCart = JSON.parse(localStorage.getItem("cart"));
      // }
      // console.log("response :>> ", response);
      this.listCart = onGetListCart();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  //Paypal && Stripe
  get publicKeyStripe() {
    // return 'pk_test_51N65klFRqDMGudAjg2cho0max9vX5lFweHZMepV03KqJEVvJfpvSCTx30FI6fxgw0ajz9mPEMhWLG3u0MnGVG1zw00BJLDsC7O'
    return this.$store.state.cart.publicKeyStripe;
  }

  get enablePaypal() {
    const listPayment = this.$store.state.cart?.listPayment || [];
    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "paypal"
    );
    if (findIndex !== -1) {
      return listPayment[findIndex]?.status;
    }
    return false;
  }

  get enableStripe() {
    const listPayment = this.$store.state.cart?.listPayment || [];
    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "stripe"
    );
    if (findIndex !== -1) {
      return this.$store.state.cart?.listPayment[findIndex]?.status;
    }
    return false;
  }

  get myIp() {
    return this.$store.state.sitePage.myIp || {};
  }

  get utm() {
    const query = this.$store.state.sitePage.utm || {};
    return objectToParam(query);
  }

  get product() {
    return this.$store.state.product?.product || {};
  }

  beforeDestroy() {
    this.isAbandon = false;
    this.abandonedId = "";
    this.code = "";
    // this.$store.commit("product/setIsScrollCheckout", false);
    if (this.isDonePayment) {
      onClearSession("card");
      onClearSession("cardHolderName");
      onClearSession("checkout");
      onClearSession("isSameAddress");
    } else {
      onSetCheckoutInfo("checkout", this.checkout);
      onSetCheckoutInfo("isSameAddress", this.isSameAddress);
    }
  }

  async onDelete(i: number) {
    const cart = onGetListCart();
    cart.splice(i, 1);
    this.listCart.splice(i, 1);
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", JSON.stringify(cart));
    if (!this.listCart.length) {
      this.priceCoupon = 0;
    }
    this.onGetListShipping();
  }

  async onGetAutoApply() {
    try {
      let total = 0;
      // this.priceCoupon = 0;
      // this.coupon = {};
      for (let product of this.listCart) {
        total += product.quantity;
      }
      const query = {
        total: parseFloat(this.totalPrice.toFixed(2)),
        quantity: total,
        shipping: this.findPriceShipping,
        slug: this.slug,
      };
      const response = await this.$api.coupon.autoApply(query);
      if (response?.data) {
        this.couponCode = response.data.code;
        this.coupon = response.data;
        if (response.data.discountType === 1) {
          this.priceCoupon = (this.totalPrice * response.data.discount) / 100;
        } else if (response.data.discountType === 2) {
          this.priceCoupon =
            response.data.discount > this.totalPrice
              ? this.totalPrice
              : response.data.discount;
        } else {
          this.priceCoupon = this.findPriceShipping;
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  async onHandlePaymentPaypal() {
    try {
      if (!this.checkFieldBeforePayment()) {
        return this.$pushNotification.error(`Please enter all fields`);
      }
      if (!this.checkout.shippingAddress.email) {
        return this.$pushNotification.error(`Please enter your email`);
      }
      if (!this.checkout.shippingAddress.phoneNumber) {
        return this.$pushNotification.error(`Please enter your phone number`);
      }
      this.loading = true;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  // ------------------------------------------------------------------------------------------ END THANH TOÁN BẰNG STRIPE  -------------------------------------------------------------------------------------
  checkFieldBeforePayment() {
    const { email, firstName, lastName, address, country, phoneNumber } =
      this.checkout.shippingAddress;
    if (!(firstName && lastName && address && country)) {
      return false;
    }

    return true;
  }
  // ------------------------------------------------------------------------------------------ THANH TOÁN BẰNG PAYPAL  -------------------------------------------------------------------------------------
  slug = "";
  couponCode = "";
  // ------------------------------------------------------------------------------------------ THÔNG TIN ẢNH, MÃ GIẢM GIÁ, TÍNH GIÁ TIỀN  -------------------------------------------------------------------------------------
  priceCoupon = 0;
  async onCheckCodeCoupon() {
    try {
      if (!this.code) {
        return this.$pushNotification.error("Coupon cannot be left blank");
      }
      this.couponCode = "";
      this.priceCoupon = 0;
      this.loadingDiscount = true;
      const response = await this.$api.coupon.getCouponBycode(
        this.code,
        this.slug
      );
      if (response?.data) {
        let quantityAll = 0;
        const { minAmount, minQuantity } = response.data;
        if (this.totalPrice < minAmount) {
          this.loadingDiscount = false;
          return this.$pushNotification.error(
            "The order's subtotal amount is not enough to apply this discount code"
          );
        }
        for (let item of this.listCart) {
          quantityAll += item.quantity;
        }
        if (quantityAll < minQuantity) {
          this.loadingDiscount = false;
          return this.$pushNotification.error(
            `You need to buy ${
              minQuantity - quantityAll
            } more items to apply this discount`
          );
        }
        const { dateFrom, dateTo } = response.data;
        const date = moment().unix();
        // Check the discount code has been applied or expired
        if (dateFrom && date < dateFrom) {
          this.loadingDiscount = false;
          return this.$pushNotification.error(
            "Discount code is not applicable yet"
          );
        }
        if (dateTo && date > dateTo) {
          this.loadingDiscount = false;
          return this.$pushNotification.error("Expired discount code");
        }
        this.checkout.couponCode = response.data.code;
        this.coupon = response.data;
        if (response.data.discountType === 1) {
          this.priceCoupon = (this.totalPrice * response.data.discount) / 100;
        } else if (response.data.discountType === 2) {
          this.priceCoupon =
            response.data.discount > this.totalPrice
              ? this.totalPrice
              : response.data.discount;
        } else {
          this.priceCoupon = this.findPriceShipping;
        }
        this.$pushNotification.success("Apply coupon successfully");
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
    {
      this.loadingDiscount = false;
    }
  }
  countryCodePayment = "";
  nameShipping = "";
  async onGetListShipping(country?: string) {
    try {
      this.loadingTable = true;
      this.countryCodePayment = country || this.myIp.countryCode || "";
      const domain = this.$store.state?.product?.domain || "";
      const response = await this.$api.shipping.listShipping(
        domain,
        this.countryCodePayment,
        this.siteInfo.adminId
      );
      if (response?.data?.length) {
        this.listShipping = response.data;
        if (this.listCart && this.listCart.length) {
          let total = 0;
          let totalPrice = Math.round(this.totalPrice * 100) / 100;
          for (let product of this.listCart) {
            total += product.quantity;
          }

          let findGreatThanShipping: any = {};
          let listShippingFilter = response.data.filter(
            (shipping: any) =>
              shipping.quantity <= total || shipping.total <= totalPrice
          );

          // listShippingFilter.sort((a: any, b: any) => {
          //   return b.price - a.price;
          // });
          if (listShippingFilter.length) {
            this.nameShipping = listShippingFilter[0]?.name || "Shipping";
            let findPriceGood: any = {};
            let findQuantityGood: any = {};
            for (let shipping of listShippingFilter) {
              if (shipping.quantity <= total) {
                findQuantityGood = shipping;
              }
              if (shipping.total <= totalPrice) {
                findPriceGood = shipping;
              }
              // if (shipping.quantity <= total) {
              //   console.log('vao');
              //   findGreatThanShipping = shipping;
              // }
              // if (shipping.total <= totalPrice) {
              //   findGreatThanShipping = shipping;
              // }
            }
            if (findQuantityGood && findQuantityGood._id) {
              findGreatThanShipping = findQuantityGood;
            }
            if (findPriceGood && findPriceGood._id) {
              findGreatThanShipping = findPriceGood;
            }
            // for (let shipping of listShippingFilter) {
            //   if(shipping.total){

            //   }
            //   // if (shipping.price > findGreatThanShipping.price) {
            //   //   findGreatThanShipping = shipping;
            //   // }
            // }
            this.checkout.shippingId = findGreatThanShipping._id || "";
          }
          if (this.listCart.length) {
            await this.onGetAutoApply();
          }
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  convertImg(product: any) {
    if (product.imageId.imageUrl) {
      return `${api}/${product.imageId.imageUrl}`;
    }
    return "";
  }
  calcTotalPrice() {
    let price = 0;
    if (this.listCart && this.listCart.length) {
      for (let product of this.listCart) {
        price += product.price * product.quantity;
      }
    }
    return price;
  }

  calcPrice(product: any) {
    if (product?.comparePrice) {
      return product.comparePrice * product.quantity;
    }
    return product.price * product.quantity;
  }

  async onCreateCart() {
    try {
      await this.$store.dispatch("cart/createCart", { ctx: this });
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  get totalPrice() {
    let price = 0;
    if (this.listCart && this.listCart.length) {
      for (let product of this.listCart) {
        price += product.price * product.quantity;
      }
    }
    return price;
  }

  totalPriceFree = 0;

  priceDiscount(totalPrice: number) {
    let price = 0;
    if (this.listCart && this.listCart.length) {
      for (let product of this.listCart) {
        price += product.price * product.quantity;
      }
    }
    let priceCoupon = 0;
    if (this.coupon && this.coupon._id) {
      if (this.coupon.type === 1) {
        priceCoupon = (price * this.coupon.value) / 100;
      } else {
        priceCoupon = this.coupon.value;
      }
    }
    return totalPrice - price + priceCoupon;
  }

  get findPriceShipping() {
    if (this.listCart && this.listCart.length) {
      const findShip: any = this.listShipping.find(
        (shipping: any) => shipping._id === this.checkout.shippingId
      );
      if (findShip) {
        return findShip.price;
      }
    }
    return 0;
  }
  get convertImage() {
    const siteInfo = this.$store.state.setting.siteInfo;
    if (siteInfo && siteInfo.logo) {
      return `${api}/${siteInfo.logo}`;
    }
  }

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  calcTotalPriceAll(
    totalPrice: any,
    findPriceShipping: any,
    tip: any,
    priceDiscount: any
  ) {
    return (
      parseFloat(totalPrice || 0) +
      parseFloat(findPriceShipping || 0) +
      parseFloat(tip) -
      parseFloat(priceDiscount.toFixed(2))
    ).toFixed(2);
  }
  calcPriceTip(subTotal: number, percent: number, priceDiscount: number) {
    return (((subTotal - priceDiscount) * percent) / 100).toFixed(2);
  }

  onSetPercentTip(percent: number, val: number) {
    this.checkout.tip = val;
    this.percentTip = percent;
    this.amountTip = null;
  }

  isErrorPriceTip = 0;

  minutes = 8;
  second = 59;

  countdownTimer() {
    this.second -= 1;
    if (this.second === 0 && this.minutes > 0) {
      this.second = 59;
      this.minutes -= 1;
    }
    if (this.minutes === 0 && this.second === 0) {
      clearInterval(this.timerInterVal);
    }
  }
  onSetTip() {
    this.isErrorPriceTip = 0;
    if (
      this.amountTip >
      this.totalPrice - this.priceDiscount(this.totalPrice)
    ) {
      this.isErrorPriceTip =
        this.totalPrice - this.priceDiscount(this.totalPrice);
      return;
    }
    this.checkout.tip = this.amountTip;
  }

  timer = "";
  onCalcTimer() {
    const that = this;
    const promotion = that.$store.state.promotion.promotion;
    if (promotion.status === 1) {
      var x = setInterval(function () {
        // Get today's date and time
        var now = new Date().getTime();
        // Find the distance between now and the count down date
        var distance = promotion.to * 1000 - now;
        // Time calculations for days, hours, minutes and seconds
        var days = Math.floor(distance / (1000 * 60 * 60 * 24));
        var hours = Math.floor(
          (distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60)
        );
        var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
        var seconds = Math.floor((distance % (1000 * 60)) / 1000);
        that.timer = `${
          days
            ? days < 10
              ? `0${days} ${days > 1 ? `days` : "day"} `
              : `${days} ${days > 1 ? `days` : "day"} `
            : ""
        }${hours ? (hours < 10 ? `0${hours}:` : `${hours}:`) : "00:"}${
          minutes ? (minutes < 10 ? `0${minutes}:` : `${minutes}:`) : "00:"
        }${seconds ? (seconds < 10 ? `0${seconds}` : `${seconds}`) : ""}`;
        if (distance < 0) {
          clearInterval(x);
          that.timer = "";
        }
      }, 1000);
    }
  }

  get logo() {
    const siteInfo = this.$store.state?.setting?.siteInfo;
    if (siteInfo?.logo?.imageUrl) {
      return `${api}/${siteInfo.logo.imageUrl}`;
    } else if (siteInfo?.logo) {
      return `${api}/${siteInfo.logo}`;
    }
    return "/logous.png";
  }

  get showState() {
    return (
      this.checkout.shippingAddress.country === "United States" ||
      this.checkout.shippingAddress.country === "Australia" ||
      this.checkout.shippingAddress.country === "Canada"
    );
  }

  get showBillingState() {
    return (
      this.checkout.billingAddress.country === "United States" ||
      this.checkout.billingAddress.country === "Australia" ||
      this.checkout.billingAddress.country === "Canada"
    );
  }

  onChangeCountry() {}

  @Watch("paymentType")
  changedPaymentType(val: string) {
    if (val === "1") {
      this.checkout.payment = "cod";
    } else if (val === "2") {
      this.checkout.payment = "paypal";
    }
  }

  @Watch("addTip")
  changedAddTip(val: boolean) {
    if (val) {
      this.percentTip = 5;
    } else {
      this.percentTip = null;
      this.checkout.tip = 0;
    }
  }

  @Watch("percentTip")
  changedPercentTip(val: number) {
    if (val) {
      this.isErrorPriceTip = 0;
      this.onSetPercentTip(
        val,
        parseFloat(
          this.calcPriceTip(
            this.totalPrice,
            val,
            this.priceDiscount(this.totalPrice)
          )
        )
      );
    }
  }

  // @Watch("card.cvv")
  // onPropertyChangedCVV(value: string) {
  // 	if (value.length > 3) {
  // 		setTimeout(() => {
  // 			this.card.cvv = value.slice(0, 3);
  // 		}, 50);
  // 	}
  // }

  countrySelect = "";

  onCreateAbandonedFromEmail() {
    if (regexEmail.test(this.checkout.shippingAddress.email)) {
      this.onCreateAbandoned();
    }
  }

  onGetPriceShippng() {
    if (this.checkFieldBeforePayment()) {
      const findCountry = countryCode.find(
        (item: IItemCountry) =>
          item.name === this.checkout.shippingAddress.country
      );
      if (findCountry && findCountry.code) {
        this.countrySelect = findCountry.code;
        this.onGetListShipping(findCountry.code);
      }
    } else {
      this.onGetListShipping();
      this.countrySelect = "";
    }
  }

  findCountryName(quocgia: string) {
    const findCountry: any = this.listAllCountry.find(
      (country: any) => country.code === quocgia
    ) || { name: "", code: "" };

    return findCountry.name || "";
  }

  countTrackAddInfoPayment = 0;

  formatPhoneNumber(phoneNumberString: string) {
    var cleaned = ("" + phoneNumberString).replace(/\D/g, "");
    var match = cleaned.match(/^(1|)?(\d{3})(\d{3})(\d{4})$/);
    if (match) {
      var intlCode = match[1] ? "1 " : "";
      return [intlCode, , match[2], " ", match[3], " ", match[4]].join("");
    }
    return this.card_format(phoneNumberString);
  }

  card_format(value: string) {
    value = value.toString();
    var v = value.replace(/\s+/g, "").replace(/[^0-9]/gi, "");
    var matches = v.match(/\d{3,16}/g);
    var match = (matches && matches[0]) || "";
    var parts = [];

    for (let i = 0, len = match.length; i < len; i += 3) {
      parts.push(match.substring(i, i + 3));
    }

    if (parts.length) {
      return parts.join(" ");
    } else {
      return value;
    }
  }

  @Watch("checkout.shippingAddress.phoneNumber")
  changedShippingPhoneNumber(value: string) {
    if (value) {
      this.checkout.shippingAddress.phoneNumber = this.formatPhoneNumber(value);
    }
  }

  @Watch("checkout.billingAddress.phoneNumber")
  changedBillingPhoneNumber(value: string) {
    if (value) {
      this.checkout.billingAddress.phoneNumber = this.formatPhoneNumber(value);
    }
  }

  @Watch("checkout.shippingAddress.email")
  changedEmail() {
    if (this.countTrackAddInfoPayment === 0) {
      this.countTrackAddInfoPayment = 1;
    }
  }

  @Watch("checkout.shippingAddress.country")
  changedCountry(value: string) {
    this.onGetPriceShippng();
    if (value === "United States") {
      this.listStateCountry = usStates;
    } else if (value === "Australia") {
      this.listStateCountry = australiaState;
    } else if (value === "Canada") {
      this.listStateCountry = canadaState;
    } else {
      this.listStateCountry = [];
      this.checkout.shippingAddress.state = "";
    }

    this.setStateCheckout("shipping");
  }

  @Watch("checkout.billingAddress.country")
  changedBillingCountry(value: string) {
    this.onGetPriceShippng();
    if (value === "United States") {
      this.listStateBillingCountry = usStates;
    } else if (value === "Australia") {
      this.listStateBillingCountry = australiaState;
    } else if (value === "Canada") {
      this.listStateBillingCountry = canadaState;
    } else {
      this.listStateBillingCountry = [];
      this.checkout.billingAddress.state = "";
    }

    this.setStateCheckout("billing");
  }

  setStateCheckout(type?: string) {
    this.listStateCountry.unshift({
      name: "Choose your state",
      abbreviation: "",
    });
    this.listStateBillingCountry.unshift({
      name: "Choose your state",
      abbreviation: "",
    });
    if (this.listStateCountry.length) {
      //@ts-ignore
      if (type === "shipping") {
        this.checkout.shippingAddress.state = this.listStateCountry[0].name;
      } else if (type === "billing") {
        this.checkout.billingAddress.state =
          this.listStateBillingCountry[0].name;
      } else {
        this.checkout.shippingAddress.state = this.listStateCountry[0].name;
        this.checkout.billingAddress.state =
          this.listStateBillingCountry[0].name;
      }
    }
  }

  checkTip(evt: any) {
    evt = evt ? evt : window.event;
    let expect = evt.target.value.toString() + evt.key.toString();

    if (!/^[-+]?[0-9]*\.?[0-9]*$/.test(expect)) {
      evt.preventDefault();
    } else {
      return true;
    }
  }

  @Watch("checkout.tip")
  changedTip(value: number) {
    // if (typeof value === "string" && value === "" && value < 0) {
    //   this.checkout.tip = 0;
    // }
    // localStorage.setItem("tip", JSON.stringify(this.checkout.tip));
  }

  @Watch("$vuetify.breakpoint.name")
  changedBreakpoint(value: string) {
    if (value === "xs" || value === "sm") {
      this.isShowListProduct = false;
    } else {
      this.isShowListProduct = true;
    }
  }

  @Watch("isSameAddress")
  changedIsSameAddress(value: string) {
    //@ts-ignore
    const checkout = JSON.parse(onGetCheckoutInfo("checkout"));
    if (value === "1") {
      if (
        !checkout?.billingAddress?.firstName ||
        !checkout?.billingAddress?.firstName
      ) {
        this.checkout.billingAddress = {
          email: "",
          firstName: "",
          lastName: "",
          address: "",
          apartment: "",
          zipCode: "",
          city: "",
          state: "Choose your state",
          country: "United States",
          phoneNumber: "",
        };
      }
    }
    if (value === "0") {
      if (
        checkout?.billingAddress?.firstName ||
        checkout?.billingAddress?.firstName
      ) {
        this.checkout.billingAddress = {
          email: "",
          firstName: "",
          lastName: "",
          address: "",
          apartment: "",
          zipCode: "",
          city: "",
          state: "Choose your state",
          country: "United States",
          phoneNumber: "",
        };
      }
    }
  }
}
</script>

<style src="./style.scss" lang="scss" scoped></style>
<style>
#hideBottomInput.input-tip .v-text-field--outlined fieldset {
  /* border: 1px solid #ddd; */
  /* box-shadow: inset 0 0.0625em 0.125em rgb(10 10 10 / 5%) !important; */
}

#hideBottomInput .v-input--is-focused .v-input__slot {
  border-color: #485fc7;
  box-shadow: 0 0 0 0.15em rgba(72, 95, 199, 0.25);
}

#hideBottomInput.input-tip .v-text-field--outlined fieldset {
  /* bottom: -3px;
  top: -3px; */
  border-collapse: collapse;
  border-color: currentColor;
  border-style: solid;
  border-width: 0px;
}

#hideBottomInput.input-tip .v-input__slot {
  height: 48px;
}

#hideBottomInput.input-tip {
  border-radius: 6px;
  border: 1px solid #9ca3af;
  height: 48px;
}

#payment #hideBottomInput .v-input__slot {
  min-height: 48px !important;
}

#hideBottomInput.input-tip .custom-tips {
  border-radius: 6px;
  background: #e1effe;
  color: #3f83f8;
}

.link-cart a {
  text-decoration: none;
}

.link-cart a:hover {
  text-decoration: underline;
  color: #3f83f8;
}

.card-holder-name
  .v-input
  .v-input__control
  .v-input__slot
  .v-text-field__slot
  input {
  text-transform: uppercase !important;
}
</style>
